

class MxRibbon:
    RIBBON_UNKNOWN = "UNKNOWN"

    RIBBON_MAIN_CALIBER = "RIBBON_MAIN_CALIBER"
    RIBBON_TORPEDO = "RIBBON_TORPEDO"
    RIBBON_BOMB = "RIBBON_BOMB"
    RIBBON_PLANE = "RIBBON_PLANE"
    RIBBON_CRIT = "RIBBON_CRIT"
    RIBBON_FRAG = "RIBBON_FRAG"
    RIBBON_BURN = "RIBBON_BURN"
    RIBBON_FLOOD = "RIBBON_FLOOD"
    RIBBON_CITADEL = "RIBBON_CITADEL"
    RIBBON_BASE_DEFENSE = "RIBBON_BASE_DEFENSE"
    RIBBON_BASE_CAPTURE = "RIBBON_BASE_CAPTURE"
    RIBBON_BASE_CAPTURE_ASSIST = "RIBBON_BASE_CAPTURE_ASSIST"
    RIBBON_SUPPRESSED = "RIBBON_SUPPRESSED"
    RIBBON_SECONDARY_CALIBER = "RIBBON_SECONDARY_CALIBER"
    RIBBON_MAIN_CALIBER_OVER_PENETRATION = "RIBBON_MAIN_CALIBER_OVER_PENETRATION"
    RIBBON_MAIN_CALIBER_PENETRATION = "RIBBON_MAIN_CALIBER_PENETRATION"
    RIBBON_MAIN_CALIBER_NO_PENETRATION = "RIBBON_MAIN_CALIBER_NO_PENETRATION"
    RIBBON_MAIN_CALIBER_RICOCHET = "RIBBON_MAIN_CALIBER_RICOCHET"
    RIBBON_BUILDING_KILL = "RIBBON_BUILDING_KILL"
    RIBBON_BOMB_OVER_PENETRATION = "RIBBON_BOMB_OVER_PENETRATION"
    RIBBON_BOMB_PENETRATION = "RIBBON_BOMB_PENETRATION"
    RIBBON_BOMB_NO_PENETRATION = "RIBBON_BOMB_NO_PENETRATION"
    RIBBON_ROCKET = "RIBBON_ROCKET"
    RIBBON_BOMB_RICOCHET = "RIBBON_BOMB_RICOCHET"
    RIBBON_DETECTED = "RIBBON_DETECTED"
    RIBBON_ROCKET_PENETRATION = "RIBBON_ROCKET_PENETRATION"
    RIBBON_ROCKET_NO_PENETRATION = "RIBBON_ROCKET_NO_PENETRATION"
    RIBBON_SPLANE = "RIBBON_SPLANE"
    RIBBON_BULGE = "RIBBON_BULGE"
    RIBBON_BOMB_BULGE = "RIBBON_BOMB_BULGE"
    RIBBON_ROCKET_BULGE = "RIBBON_ROCKET_BULGE"
    RIBBON_ROCKET_RICOCHET = "RIBBON_ROCKET_RICOCHET"
    RIBBON_ROCKET_OVER_PENETRATION = "RIBBON_ROCKET_OVER_PENETRATION"

    _type_map = {
        0: RIBBON_MAIN_CALIBER,
        1: RIBBON_TORPEDO,
        2: RIBBON_BOMB,
        3: RIBBON_PLANE,
        4: RIBBON_CRIT,
        5: RIBBON_FRAG,
        6: RIBBON_BURN,
        7: RIBBON_FLOOD,
        8: RIBBON_CITADEL,
        9: RIBBON_BASE_DEFENSE,
        10: RIBBON_BASE_CAPTURE,
        11: RIBBON_BASE_CAPTURE_ASSIST,
        12: RIBBON_SUPPRESSED,
        13: RIBBON_SECONDARY_CALIBER,
        14: RIBBON_MAIN_CALIBER_OVER_PENETRATION,
        15: RIBBON_MAIN_CALIBER_PENETRATION,
        16: RIBBON_MAIN_CALIBER_NO_PENETRATION,
        17: RIBBON_MAIN_CALIBER_RICOCHET,
        18: RIBBON_BUILDING_KILL,
        19: RIBBON_DETECTED,
        20: RIBBON_BOMB_OVER_PENETRATION,
        21: RIBBON_BOMB_PENETRATION,
        22: RIBBON_BOMB_NO_PENETRATION,
        23: RIBBON_BOMB_RICOCHET,
        24: RIBBON_ROCKET,
        25: RIBBON_ROCKET_PENETRATION,
        26: RIBBON_ROCKET_NO_PENETRATION,
        27: RIBBON_SPLANE,
        28: RIBBON_BULGE,
        29: RIBBON_BOMB_BULGE,
        30: RIBBON_ROCKET_BULGE,
        34: RIBBON_ROCKET_RICOCHET,
        35: RIBBON_ROCKET_OVER_PENETRATION,
    }

    def __init__(self, ribbon_id):
        if ribbon_id in MxRibbon._type_map:
            self._type = MxRibbon._type_map[ribbon_id]
        else:
            self._type = MxRibbon.RIBBON_UNKNOWN

    _puk_map = {
        RIBBON_FRAG: 1.0/5.0,
        RIBBON_PLANE: 1.0/30.0,
        RIBBON_BASE_CAPTURE: 1.0/3.0,
        RIBBON_DETECTED: 1.0/10.0/12.0,
    }

    def getPuk(self):
        if self._type in MxRibbon._puk_map:
            return MxRibbon._puk_map[self._type]
        else:
            return 0.0
